

import java.util.HashMap;

import edu.berkeley.guir.prefuse.graph.DefaultEdge;
import edu.berkeley.guir.prefuse.graph.DefaultGraph;
import edu.berkeley.guir.prefuse.graph.Graph;

public class PhotoArc {
    /**
     * Returns a graph structured as multiple arcs of photos, one 
     * arc for each array.
     * @param photoArcs, an array of arrays of image names
     * @return a PhotoArc graph
     */
	// private static HashMap photos;
	
    public static Graph getArc(String[][] photoArcs) {
        Graph g = new DefaultGraph();
		HashMap photos = new HashMap();
        for (int j = 0; j < photoArcs.length; j++ ){
        	String[] photoLocations = photoArcs[j];
        	int n = photoLocations.length+2;
        	PhotoArcNode[] nodes = new PhotoArcNode[n];
        	for ( int i = 0; i < n; i++ ) {
        		if (i == 0){
        			nodes[i] = new PhotoArcNode();
        			nodes[i].setAttribute("identifier", "start");
        			g.addNode(nodes[i]);
        		} else if (i == n-1){
        			nodes[i] = new PhotoArcNode();
        			nodes[i].setAttribute("identifier", "end");
        			g.addNode(nodes[i]);
        		} else {
            		if (photos.containsKey(photoLocations[i-1])) {
            			nodes[i] = (PhotoArcNode) photos.get(photoLocations[i-1]);
            			System.out.println("Edges: " + nodes[i].getEdgeCount());
            		} else {
            			nodes[i] = new PhotoArcNode();
            			nodes[i].setAttribute("image", photoLocations[i-1]);
            			photos.put(photoLocations[i-1], nodes[i]);
            			g.addNode(nodes[i]);
            		}
        		}
        		if (i > 0){
        			g.addEdge(new DefaultEdge(nodes[i-1], nodes[i]));
        		}
        	}
        }
        return g;
    } //
}
